
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        imarith.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of mdist_cor_sp.pl
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  08.08.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>


#include <stdio.h> //For Standard I/O
#include <ctype.h> //For Type check
#include <string.h> //For String manipulation
#include <math.h> //For Math functions
#include <data_io.h> //For Lyon I/O data

#include <cpgplot.h> // PGPLOT
#include "my_math.h"


main(int argc, char *ARGV[])
{
     FILE *FH;
     char infile[80],dist_file[80],dist_txt[80],out_file[80];
     int plot;
     float offset;
     float *shift_all;
     int nd,flag,itmp,j,i;
     char car;
     float tmp;
     float *a_dist;
     long npix[2];
     double start[2];
     double step[2];
     IMAGE2D image,dist,dist_cor;
     float *spec,*w,*out_spec,*out_array;
     float *a_i_old;

     if (argc<4) {
	 printf("USE: dist_cor_external.pl EXTRACTED.fits DISTORTION.txt OUTPUT.fits plot [offset]\n");
	 return(0);
     }
     set_user_dataformat();
     strcpy(infile,ARGV[1]);    
     strcpy(dist_txt,ARGV[2]);    
     strcpy(out_file,ARGV[3]);        
     plot=atoi(ARGV[4]);
     offset=0;
     if (argc==6) {
	 offset=atof(ARGV[5]);
     }

/*
 * We read the distortion ASCII file
 */
     nd=0;
     if ((FH=fopen(dist_txt,"r"))==NULL) {
	 printf("Error opening file: %s\n",dist_txt);
	 return(-1);
     } else {    
	 while((car=getc(FH))!=EOF) {
	     flag=1;
	     if (car=='\n')
	     {
		 nd+=1;
		 flag+=1;
	     }
	 }
	 if (flag==1) {
	     nd=nd+1;
	 } else {
	     nd=nd;
	 }
	 rewind(FH);
	 shift_all = (float *)malloc((nd)*sizeof(float));  	
	 for (j=0;j<nd;j++) {
	     fscanf(FH, "%f", &tmp);
	     fscanf(FH, "%f", &tmp);
	     shift_all[j]=tmp;
//	     printf("%d %f\n",j,shift_all[j]);
	 }
     }
     fclose(FH);

//     printf("ND=%d\n",nd);

/*
 * We read the distorion FITS file
 */
/*
    open_frame(&dist,dist_file,"I");
    a_dist = (float *)malloc((dist.nx*dist.ny)*sizeof(float));  	
    for (i=0;i<dist.nx;i++) {
	for (j=0;j<dist.ny;j++) {
	    a_dist[i+j*dist.nx]=RD_frame(&dist,i,j)+shift_all[j];
	}
    }
    close_frame(&dist);
*/

/*
 * Reading the in-file
 */
    open_frame(&image,infile,"I");
    npix[0]=image.nx;
    npix[1]=image.ny;
    start[0]=0.0;
    start[1]=0.0;
    step[0]=1.0;
    step[1]=1.0;
    
    out_array = (float *)malloc((image.nx*image.ny)*sizeof(float)); 
    a_i_old = (float *)malloc((image.nx)*sizeof(float));  
    w = (float *)malloc((image.nx)*sizeof(float));  
    spec = (float *)malloc((image.nx)*sizeof(float));  
    out_spec = (float *)malloc((image.nx)*sizeof(float));  

    printf("Correcting the distortion...\n");
    for (j=0;j<npix[1];j++) {
	for (i=0;i<npix[0];i++) {
//	    a_dist[i+j*dist.nx]=RD_frame(&dist,i,j)+shift_all[j];
	    a_i_old[i]=1.0*i+shift_all[j];
	    spec[i]=RD_frame(&image,i,j);
	    w[i]=1.0*i;
	}
	spline1(w,spec,npix[0],a_i_old,out_spec,npix[0]);	
//spline1(w,spec,npix[0],a_i_old,out_spec,npix[0]);
	for (i=0;i<npix[0];i++) {
	    out_array[i+j*npix[0]]=out_spec[i];
	}
    }
//    close_frame(&image);     

    printf("Writting the corrected data: %s\n",out_file);
    create_frame(&dist_cor,out_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
    for (i=0;i<npix[0];i++) {
	for (j=0;j<npix[1];j++) {
	    WR_frame(&dist_cor,i,j,out_array[i+j*npix[0]]);
	}
    }
    close_frame(&dist_cor);    

    close_frame(&image);

    return(0);
}


/*
#!/usr/bin/perl
#
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;

#require "/work1/ssa/perl/MY/my.pl";
require "/home/sanchez/sda1/perl/MY/my.pl";


if (#ARGV<4) {
    print "USE: mdist_cor_external.pl EXTRACTED.fits DISTORTION.txt DISTORSION.fits OUTPUT.fits plot [offset]\n";
    exit;
}





print "Reading file infile ";
nax=read_naxes(infile);   
@naxis=@nax;
nx=naxis[0];
ny=naxis[1];
@in_array=read_img(infile);
print "DONE\n";

if (dist_txt ne "none") {
    print "Reading the distortion correction\n";
    open(FH,"<dist_txt");
    nd=0;
    shift_min=1e12;
    shift_max=-1e12;
    while(line=<FH>) {
	chop(line);
	@data=split(" ",line);
	index_all[nd]=data[0];
	shift_all[nd]=data[1]+offset;
	if (shift_min>shift_all[nd]) {
	    shift_min=shift_all[nd];
	}
	if (shift_max<shift_all[nd]) {
	    shift_max=shift_all[nd];
	}
	nd++;
    }
    close(FH);
    print "DONE\n";
} else {
    for (nd=0;nd<ny;nd++) {
	shift_all[nd]=0;
    }
}

#ny_cen=int(ny/2);
#shift_cen=shift_all[ny_cen];
#for (j=0;j<nd;j++) {
#    shift_all[j]=shift_all[j]-shift_cen;
#    print "j shift_all[j]\n";
#}


print "Reading 2nd order distortion dist_file ";
@a_dist=read_img(dist_file);
print "DONE\n";


#
# We correct for the new dispersion
#
my @out_array;
for (j=0;j<ny;j++) {
    for (i=0;i<nx;i++) {
	a_i_old[i]=a_dist[j][i];
	spec[i]=in_array[j][i];
	wave[i]=i;
    }
    my out_spec_pdl = interpol(pdl(@a_i_old), pdl(@wave), pdl(@spec));
    min=1e12;
    max=-1e12;
    for (i=0;i<nx;i++) {
	wave_new[i]=i;
	out_spec[i]=out_spec_pdl->at(i);
	out_array[j][i]=out_spec[i];
	if (min>spec[i]) {
	    min=spec[i];
	}
	if (max<spec[i]) {
	    max=spec[i];
	}
    }

    if (plot==1) {
	pgbegin(0,"/xs",1,1);
	pgsfs(1.2);
	pgscf(2);             # Set character font
	pgslw(2);             # Set line width
	pgsch(1.2);           # Set character height
	pgenv(0,nx,min,max,0,0);
	pglabel("Wavelength","Counts","j/ny");
	pgsci(2);
	pgline(nx,\@wave_new,\@spec);
	pgsci(1);
	pgline(nx,\@wave_new,\@out_spec);
	pgclos();
	pgend();
	print "Press Enter";
	command=<stdin>;
	chop(command);
	if (command eq "A") {
	    plot=0;
	}
    }    
}


print "Writting the out_file\n";
system("rm out_file");
write_img(out_file,nx,ny,\@out_array);
#write_rss(out_file,n_cut,ny,crval,cdelt,\@out_array);
print "DONE\n";

exit;

*/
