/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
! COPYRIGHT    (c)  2005 CAHA, Spain
! IDENT        extract_aper.c
! LANGUAGE     C
! AUTHOR       S.F.Sanchez
! KEYWORDS     
! PURPOSE      C version of extract_aper.c
! COMMENT      No GROUP information included. No header data properly copied
! VERSION      0.1  08.08.05 : Creation, SF.
------------------------------------------------------------------------------*/

#include <IFU_io.h>

#include "stats.h"
#include <stdlib.h>



#define NB_SPEC 256
#define NPIX 1024





main(int argc, char *ARGV[])
{

  
    IMAGE2D image,trace,output;
    
    float *array,*tmp_array;
    char infile[80],trace_file[80],out_file[80];
    int spec_axis,i,k,j_min,j_max,j;
    float q;
    float y_shift,a,in_array,w;
    float peak_y_max_new,range,flux,sum_w;

    char **argval, **arglabel;
    long npix[2];
    double start[2];
    double step[2];
    char tmp_char[80];
    float aperture;
    int J_max;

    if (argc<6) {
	printf("USE: extract_aper RAW.fits Spectral_axis[0/1] TRACE.fits Aperture OUTPUT.fits [SHIFT]\n");
	return(0);
    }
     set_user_dataformat();
//    init_session(ARGV,argc,&arglabel,&argval);

    strcpy(infile,ARGV[1]);
    spec_axis=atoi(ARGV[2]);
    strcpy(trace_file,ARGV[3]);
//    aperture=strtod(ARGV[4], (char **)NULL);
    aperture=atof(ARGV[4]);

    strcpy(out_file,ARGV[5]);

    y_shift=0;
    if (argc==7) {
	y_shift=atof(ARGV[6]);
    }

    printf("Reading file infile '%s'",infile);
    open_frame(&image,infile,"I");
    printf("DONE\n");
    printf("Reading file trace_file '%s'",trace_file);
    open_frame(&trace,trace_file,"I");
    printf("DONE\n");
    printf("Creating the output file '%s'",out_file);

    if (spec_axis==0) {
	if (trace.nx!=image.nx) {
	    printf("The X-dimension of the trace file (trace_file), nx_tr\n");
	    printf("does not match that of the original image, nx\n");
	    printf("%d!=%d",trace.nx,image.nx);
	    return(0);
	}    
    } else {
	if (trace.nx!=image.ny) {
	    printf("The Y-dimension of the trace file (trace_file), nx_tr\n");
	    printf("does not match that of the original image, nx\n");
	    printf("%d!=%d",trace.nx,image.nx);
	    return(0);
	}    
    }
    if (spec_axis==0) {
	npix[0]=image.nx;
	npix[1]=trace.ny;
	J_max=image.ny;
    } else {
	npix[0]=image.ny;
	npix[1]=trace.ny;
	J_max=image.nx;
    }
    start[0]=0.0;
    start[1]=0.0;
    step[0]=1.0;
    step[1]=1.0;
    create_frame(&output,out_file,npix,start,step,FLOAT,"EXTRACTED",NULL);
    printf("DONE\n");

    


    a=0.5*aperture;
    printf("Extracting...");


    for (i=0;i<trace.nx;i++) {
/*
	if (i==50*nearbyint(i/50)) {
	    printf("%d,%d\n",i,image.nx);
	}
*/
	for (k=0;k<trace.ny;k++) {
	    peak_y_max_new=RD_frame(&trace,i,k)+y_shift;	
	    range=(1.5*aperture);

	    j_min=round(peak_y_max_new-range);
	    j_max=round(peak_y_max_new+range);

/*
	    j_min=floor(peak_y_max_new-range);
	    j_max=floor(peak_y_max_new+range);
*/
//	    printf("%d %f %f %f %f %d %d\n",k,peak_y_max_new,range,(peak_y_max_new-range),(peak_y_max_new+range),j_min,j_max);
	    if (j_min<0) {
		j_min=0;
	    }
	    if (j_max>=J_max) {
		j_max=J_max-1;
	    }
	    flux=0;
	    sum_w=0;
	    q=peak_y_max_new;
//	    printf("%d %d,%d %f,%f %f,%f\n",k,j_min,j_max,peak_y_max_new,range,a,aperture);

	    for (j=j_min;j<j_max;j++) {
		if (spec_axis==0) {
		    in_array=RD_frame(&image,i,j);
		} else {
		    in_array=RD_frame(&image,j,i);
		}
		w=0;

		if (((q-a)<=(j-0.5))&&((q+a)>=(j+0.5))) {
		    w=1;
		}

		if (((q-a)<=(j-0.5))&&((q+a)<(j+0.5))) {
		    w=q+a-(j-0.5);
		}
		if (((q-a)>(j-0.5))&&((q+a)>=(j+0.5))) {
		    w=j+0.5-(q-a);
		}

/*
		if ((j>=(q-a+1))&&(j<(q+a-1))) {
		    w=1;
		}
		if ((j>=(q-a))&&(j<(q-a+1))) {
		    w=j-(q-a);
		}
		if ((j>=(q+a-1))&&(j<(q+a))) {
		    w=(q+a)-j;
		}
*/
		if (w<0) {
		    w=0;
		}
		if (w>1) {
		    w=0;
		}
//		printf("%d (%f,%f) %f\n",j,q-a,q+a,w);
		sum_w=sum_w+w;
		flux=flux+w*in_array;
	    }
	    WR_frame(&output,i,k,flux);
	}
    }
    close_frame(&output);    
    close_frame(&trace);    
    close_frame(&image);    
    printf("DONE\n");
//    exit_session(0);
    return(0);	
}



